package org.molplexdrug.EntityBean;



import static org.jboss.seam.ScopeType.SESSION;
import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;

@Entity
@Name("rtp")
@Scope(SESSION)
@Table(name="rtp")
public class Rtp implements Serializable {

	/**
	 * 
	 */
	protected static final long serialVersionUID = 967411762527461689L;
	protected int rtp_id;
	protected int rtp_project_id;
	
	
	
	
	protected Set<RtpGoal> rtpGoal=new HashSet<RtpGoal>();
	
	

	protected DevelopmentPhase developmentPhase;
	
	@ManyToOne(fetch=FetchType.EAGER,cascade = CascadeType.ALL)
       
	@JoinColumn(name="rtp_development_phase_id",
		referencedColumnName="development_phase_id")
	public DevelopmentPhase getDevelopmentPhase(){
		return developmentPhase;
	}
	public void setDevelopmentPhase(DevelopmentPhase developmentPhase){
		this.developmentPhase=developmentPhase;
	}
	
	/*public Rtp() {
	this.rtp_project_id=rtp_project_id;
	this.rtp_development_phase_id=rtp_development_phase_id;
	
	}*/
	

	public Rtp() {
	this.rtp_project_id=1;
        
	}

	public Rtp(int rtp_id, int rtp_project_id, int rtp_development_phase_id,
			Set<RtpGoal> rtpGoal) {
		super();
		this.rtp_id = rtp_id;
		this.rtp_project_id = rtp_project_id;
		
		this.rtpGoal = rtpGoal;
		
	}

	@OneToMany(mappedBy="rtp",cascade=CascadeType.ALL,fetch=FetchType.LAZY)
	public Set<RtpGoal> getRtpGoal() {
		return rtpGoal;
	}


	public void setRtpGoal(Set<RtpGoal> rtpGoal) {
		this.rtpGoal = rtpGoal;
	}

	public Rtp(int rtp_id, int rtp_project_id, int rtp_development_phase_id) {
		super();
		this.rtp_id =rtp_id ;
		
		
		
	}
	@Id @NotNull
	@GeneratedValue( strategy = GenerationType.IDENTITY )
	@Column( name = "rtp_id" )
	public int getRtp_id() {
		return rtp_id;
	}


	public void setRtp_id(int rtp_id) {
		this.rtp_id = rtp_id;
	}


	public int getRtp_project_id() {
		return rtp_project_id;
	}


	public void setRtp_project_id(int rtp_project_id) {
		this.rtp_project_id = rtp_project_id;
	}
	@Override
	public String toString() {
		return "Rtp [rtp_id=" + rtp_id + ", rtp_project_id=" + rtp_project_id
				+ ", developmentPhase=" + developmentPhase + ", rtpGoal="
				+ rtpGoal + "]";
	}  



	

	
}
